/*
ͻ
                     WordUp Graphics Toolkit Version 4.0                    
                            Demonstration Program 23                        
                                                                            
 Makes a large 256 color, animating mouse cursor!                           
                                                                            
  PROJECT                                                             
 This program requires the files WSPR.LIB and WGT4.LIB to be linked.        
                                                                            
  DATA FILES                                                          
 Make sure that MOUSE.SPR is in your executable directory.                  
                                                                            
ͼ
*/

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <alloc.h>
#include <wgt4.h>
#include <wgtspr.h>

#define SPRITES_IN_FILE 20		// We're loading 20 sprites

int i;					// Generic counter
color palette[256];			// Our palette
block sprites[SPRITES_IN_FILE+1];	// Pointers to sprites
int quit;				// if quit !=0, program quits
int oldmode;				// Stores initial video mode


void looper(void);			// Function to move cursor


void main(void)
{
  if ( !vgadetected() )
  {
    printf("Error - VGA card required for any WGT program.\n");
    exit(0);
  }
  oldmode=wgetmode();
  vga256();

  /* Load our sprites from the file. Palette is loaded too */
  wloadsprites(palette,"mouse.spr",sprites,0,SPRITES_IN_FILE);
  wsetpalette(0,255,palette);

  /* Initialize the WGT sprite system */
  initspr();
  spon=1;			/* number of sprites on */

  minit();			/* initialize mouse */

  for (i=0; i<200; i++)		/* draw a background */
  {
    wsetcolor(i);
    wline(0,i,159,i);
    wline(160,199-i,319,199-i);
  }

  wcopyscreen(0,0,319,199,NULL,0,0,spritescreen);
  /* when using sprites, whatever is on the visual page must be on
     spritescreen too! */

  /* Also, you must make sure you turn a sprite on AFTER you draw
     the background or it will leave a black spot where the sprite
     is first shown. */
  wsetscreen(spritescreen);
  spriteon(1,160,100,1);		/* turn on any sprites */

  animate(1,"(1,30)(2,30)(3,30)(4,30)(3,30)(2,30)R");
  animon(1);
  /* animate the sprite */

  do {
    looper();		/* Position cursor where mouse is */
  } while (!quit);

  spriteoff(1);			/* turn off sprites */
  /* To be safe, turn off all sprites before ending your program.
     This will free any memory used from them. */

  deinitspr();
  mdeinit ();                   /* Deinitialize the mouse handler */
  wfreesprites(sprites,0,SPRITES_IN_FILE);	/* free memory */
  wsetmode(oldmode);			/* restore old video mode */
}


void looper(void)
{
  erasespr();		   /* clear the sprites */

  s[1].x=mx;		   /* any direct sprite movements must be placed */
  s[1].y=my;		   /* between erasespr and drawspr */
  /* This will place sprite number 1 where the mouse cursor is. */


  drawspr();		   /* draw them back on */
  wretrace();
  if (kbhit()) quit=1;
}
