/*
ͻ
                     WordUp Graphics Toolkit Version 4.0                    
                            Demonstration Program 48                        
                                                                            
 Demonstrates the use of the wremap command. A block will be loaded and     
 shown in its desired colors. It will then be shown using the default       
 palette, and then remapped and shown again with the default palette.       
 The routine will produce an image which fits the current palette as much   
 as possible.                                                               
                                                                            
  PROJECT                                                             
 This program requires the WGT4.LIB file to be linked.                      
                                                                            
  DATA FILES                                                          
 WGT1.BLK and WGT1.PAL must be in the executable directory.                 
                                                                            
ͼ
*/

#include <stdlib.h>
#include <conio.h>
#include <wgt4.h>

void main (void)
{
  block myimage;
  color desired[256], defaultpal[256];
  int oldmode;

  if ( !vgadetected() )
  {
    printf ("Error - VGA card required for any WGT program.\n");
    exit (0);
  }

  oldmode = wgetmode();		/* Store current video mode 	*/
  vga256();			/* Initialize WGT system	*/

  wtextcolor (15);            	/* Text color will be white */
  wtexttransparent (TEXTFGBG);	/* No transparencies */

  myimage = wloadblock ("wgt1.blk");	/* Load the image */
  wloadpalette ("wgt1.pal", desired);	/* And its palette */
  wreadpalette (0, 255, defaultpal);	/* Store default palette */

  wsetpalette (0, 255, desired);	/* Now set the palette */
  wputblock (0, 0, myimage, NORMAL);	/* And show the image */
  wouttextxy (10, 180, NULL, "Using image palette");
  getch ();				/* Wait for keypress */

  wsetpalette (0, 255, defaultpal);	/* Set to default palette */
  wouttextxy (10, 180, NULL, "Using default palette");
  getch ();				/* Wait for keypress */

  wremap (desired, myimage, defaultpal);/* Remap the image */
  wputblock (0, 0, myimage, NORMAL);	/* And show the image */
  wouttextxy (10, 180, NULL, "Using default palette after WREMAP");
  getch ();				/* Wait for keypress */

  wfreeblock (myimage);			/* Deallocate the image */

  wsetmode (oldmode);			/* Reset to text mode */
}